#include "ctester.h"

// #include "../capplicationfactory.h"
#include <assert.h>

namespace ceng {
namespace tester {

///////////////////////////////////////////////////////////////////////////////

CTester::CTester( int (*deleg)(), const std::string& name, const std::string& file )
{
	CTestInfo test( CDelegate( deleg ), name, file );

	CTester::GetSingletonPtr()->myTests.push_back( test );
	
	logger << "Registered test: " << name << std::endl;
}

///////////////////////////////////////////////////////////////////////////////

int CTester::GetSize() const
{ 
	return myTests.size(); 
}

//.............................................................................

std::string CTester::GetName( int i ) const
{ 
	assert( i >= 0 && i < (signed)myTests.size() ); 
	return myTests[ i ].myName;
}

//.............................................................................

std::string CTester::GetFile( int i ) const
{
	assert( i >= 0 && i < (signed)myTests.size() ); 
	return myTests[ i ].myFile;
}

///////////////////////////////////////////////////////////////////////////////

std::string CTester::GetAssertation() const
{
	// TODO
	return "";
}

	
std::string CTester::GetError() const
{
	// TODO
	return "";
}

///////////////////////////////////////////////////////////////////////////////

int CTester::ExecuteTest( int i )
{
	assert( i >= 0 && i < (signed)myTests.size() ); 
	return myTests[ i ].myDelegate.Call();	
}

///////////////////////////////////////////////////////////////////////////////
} // end of namespace tester
} // end of namespace ceng